.
indexing

	description:

		"Test features for Erl-G"

	library: "Erl-G Library"
	copyright: "Copyright (c) 2005, Andreas Leitner and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date$"
	revision: "$Revision$"

deferred class ERL_G_TEST_OUTPUT

inherit

	TS_TEST_CASE
	
	ERL_SHARED_UNIVERSE

feature -- Test reflection on generated system

	test_preson is
		local
			person_type: ERL_TYPE
			make_creation_procedure: ERL_CREATION_PROCEDURE
			person_object: ANY
			name_attribute: ERL_ATTRIBUTE
			age_attribute: ERL_ATTRIBUTE
			set_to_me_procedure: ERL_PROCEDURE
			person: PERSON
		do
			person_type := universe.type_by_name ("PERSON")
			make_creation_procedure := person_type.creation_procedure_by_name ("make")
			make_creation_procedure.apply (["Anca Dobos", 25])
			person_object := make_creation_procedure.last_result
			assert_not_equal ("person created", Void, person_object)
			assert_equal ("created object has correct type", person_type, universe.type_by_object (person_object))

			name_attribute := person_type.attribute_by_name ("name")
			name_attribute.retrieve_value (person_object, [])
			assert_equal ("correct name 1", "Anca Dobos", name_attribute.last_result)

			age_attribute := person_type.attribute_by_name ("age")
			age_attribute.retrieve_value (person_object, [])
			assert_equal ("correct age 1", 25, age_attribute.last_result)
			
			name_attribute.replace (person_object, "Joe Smith")
			name_attribute.retrieve_value (person_object, [])
			age_attribute.replace (person_object, 13)
			age_attribute.retrieve_value (person_object, [])
			assert_equal ("correct name 2", "Joe Smith", name_attribute.last_result)
			assert_equal ("correct age 2", 13, age_attribute.last_result)

			set_to_me_procedure ?= person_type.procedure_by_name ("set_to_me")
			set_to_me_procedure.apply (person_object, [])
			name_attribute.retrieve_value (person_object, [])
			age_attribute.retrieve_value (person_object, [])
			assert_equal ("correct name 3", "Andreas Leitner", name_attribute.last_result)
			assert_equal ("correct age 3", 28, age_attribute.last_result)
			
			person ?= person_object
			assert_not_equal ("assignment attempt succeeds", Void, person)

			assert_equal ("correct name 4", "Andreas Leitner", person.name)
			assert_equal ("correct age 4", 28, person.age)
		end

end
